//
//  Controller.m
//  iTunesGamePad
//
//  Created by KOYAMA Yoshiaki on Sun Aug 22 2004.
//  Copyright (c) 2004 KOYAMA Yoshiaki. All rights reserved.
//

#import "Controller.h"

@implementation Controller

#pragma mark -

#pragma mark === 関数一覧 ====

static gamePad _pad;

- (BOOL)windowShouldClose:(id)sender{
	[NSApp terminate:self];
	return YES;
}

- (void)awakeFromNib {
	pRecDevice pCurrentHIDDevice;
	NSAlert *alert;
	int result;

//	HIDBuildDeviceList (kHIDPage_GenericDesktop,kHIDUsage_GD_GamePad);
	HIDBuildDeviceList(NULL, NULL);

	pCurrentHIDDevice =[self getSetCurrentDevice];

	if (pCurrentHIDDevice == NULL) {
		alert = [[[NSAlert alloc] init] autorelease];
		[alert setMessageText:NSLocalizedString(@"MessageText",@"WARNING")];
		[alert setInformativeText:NSLocalizedString(@"InformativeText",@"SEGA GamePad is not found.")];

//		[alert setAlertStyle:NSWarningAlertStyle];
		[alert setAlertStyle:NSCriticalAlertStyle];

		[alert addButtonWithTitle:@"OK"];

/*		[alert beginSheetModalForWindow:_window modalDelegate:self
			didEndSelector:@selector(alertDidEnd:returnCode:contextInfo:)
			contextInfo:nil];
*/
		result = [alert runModal];
		if (result == NSAlertFirstButtonReturn) {
		}
		
	} else {

		_pad.a = _pad.b = _pad.c = _pad.x = _pad.y = _pad.z = _pad.l = _pad.r = _pad.start = 0;
		_pad.xx = _pad.yy = 0;

		_observation = [NSTimer scheduledTimerWithTimeInterval:0.01 target:self
			selector:@selector(observationTimer:) userInfo:nil repeats:YES];
	}	

	// 再生中に曲が変わった場合に対応するため
	_nameArtist = [NSTimer scheduledTimerWithTimeInterval:0.1 target:self
			selector:@selector(nameArtistTimer:) userInfo:nil repeats:YES];
}

/*
- (void)alertDidEnd:(NSAlert *)alert returnCode:(int)returnCode contextInfo:(void *)contextInfo {
	if (returnCode == NSAlertFirstButtonReturn) {
	}
}
*/

// ボタンが押されたかチェック
- (void)observationTimer:(id)timer {
	pRecElement pCurrentHIDElement;
	pRecDevice pCurrentHIDDevice;
	static gamePad pad;
	BOOL flag = NO;
	unsigned long flags = 0;

	pad.a = pad.b = pad.c = pad.x = pad.y = pad.z = pad.l = pad.r = pad.start = 0;
	pad.xx = pad.yy = 0;


	pCurrentHIDDevice = [self getSetCurrentDevice];
	pCurrentHIDElement = HIDGetFirstDeviceElement(pCurrentHIDDevice, kHIDElementTypeIO);

	if (pCurrentHIDElement == NULL)
		return;
	
	do {

//		NSLog(@"type:%ld usgae:%ld", pCurrentHIDElement->type, pCurrentHIDElement->usage);

		if (pCurrentHIDElement->type == 0x00000002) {
			if (((long)pCurrentHIDElement->usage) == 0x00000001) {
				pad.a = HIDGetElementValue (pCurrentHIDDevice, pCurrentHIDElement);
			} else if (((long)pCurrentHIDElement->usage) == 0x00000002) {
				pad.b = HIDGetElementValue (pCurrentHIDDevice, pCurrentHIDElement);
			} else if (((long)pCurrentHIDElement->usage) == 0x00000003) {
				pad.c = HIDGetElementValue (pCurrentHIDDevice, pCurrentHIDElement);
			} else if (((long)pCurrentHIDElement->usage) == 0x00000004) {
				pad.x = HIDGetElementValue (pCurrentHIDDevice, pCurrentHIDElement);
			} else if (((long)pCurrentHIDElement->usage) == 0x00000005) {
				pad.y = HIDGetElementValue (pCurrentHIDDevice, pCurrentHIDElement);
			} else if (((long)pCurrentHIDElement->usage) == 0x00000006) {
				pad.z = HIDGetElementValue (pCurrentHIDDevice, pCurrentHIDElement);
			} else if (((long)pCurrentHIDElement->usage) == 0x00000007) {
				pad.l = HIDGetElementValue (pCurrentHIDDevice, pCurrentHIDElement);
			} else if (((long)pCurrentHIDElement->usage) == 0x00000008) {
				pad.r = HIDGetElementValue (pCurrentHIDDevice, pCurrentHIDElement);
			} else if (((long)pCurrentHIDElement->usage) == 0x00000009) {
				pad.start = HIDGetElementValue (pCurrentHIDDevice, pCurrentHIDElement);
			}
		} else if (pCurrentHIDElement->type == 0x00000001) {
			if (((long)pCurrentHIDElement->usage) == 0x00000030) {
				pad.xx = HIDGetElementValue (pCurrentHIDDevice, pCurrentHIDElement);
			} else if (((long)pCurrentHIDElement->usage) == 0x00000031) {
				pad.yy = HIDGetElementValue (pCurrentHIDDevice, pCurrentHIDElement);
			}
		}

		pCurrentHIDElement = HIDGetNextDeviceElement(pCurrentHIDElement, kHIDElementTypeAll);

	} while (pCurrentHIDElement != NULL);

//	if ((_pad.a != pad.a) && (pad.a == 1) {
	if (_pad.a != pad.a) {
		flags += gButtonAMask;
		flag = YES;
	}

//	if ((_pad.b != pad.b) && (pad.b == 1)) {
	if (_pad.b != pad.b) {
		flags += gButtonBMask;
		flag = YES;
	}

//	if ((_pad.c != pad.c) && (pad.c == 1)) {
	if (_pad.c != pad.c) {
		flags += gButtonCMask;
		flag = YES;
	}

//	if ((_pad.x != pad.x) && (pad.x == 1)) {
	if (_pad.x != pad.x) {
		flags += gButtonXMask;
		flag = YES;
	}

//	if ((_pad.y != pad.y) && (pad.y == 1)) {
	if (_pad.y != pad.y) {
		flags += gButtonYMask;
		flag = YES;
	}
//	if ((_pad.z != pad.z) && (pad.z == 1)) {
	if (_pad.z != pad.z) {
		flags += gButtonZMask;
		flag = YES;
	}

//	if ((_pad.l != pad.l) && (pad.l == 1)) {
	if (_pad.l != pad.l) {
		flags += gButtonLMask;
		flag = YES;
	}

//	if ((_pad.r != pad.r) && (pad.r == 1)) {
	if (_pad.r != pad.r) {
		flags += gButtonRMask;
		flag = YES;
	}

//	if ((_pad.start != pad.start) && (pad.start == 1)) {
	if (_pad.start != pad.start) {
		flags += gButtonStartMask;
		flag = YES;
	}

//	if ((_pad.xx != pad.xx) && ((pad.xx == 0x00) || (pad.xx == 0xff))) {
	if (_pad.xx != pad.xx) {
		flags += gButtonXXMask;
		flag = YES;
	}
//	if ((_pad.yy != pad.yy) && ((pad.yy == 0x00) || (pad.yy == 0xff))) {
	if (_pad.yy != pad.yy) {
		flags += gButtonYYMask;
		flag = YES;
	}
	_pad.a = pad.a;
	_pad.b = pad.b;
	_pad.c = pad.c;
	_pad.x = pad.x;
	_pad.y = pad.y;
	_pad.z = pad.z;
	_pad.l = pad.l;
	_pad.r = pad.r;
	_pad.start = pad.start;

	_pad.xx = pad.xx;
	_pad.yy = pad.yy;
		
	if (flag == YES)
		[self pushGamePad:flags];
}

// 曲名、アーティスト名を表示
- (void)nameArtistTimer:(id)timer {
	[self setNameArtist];
}

// アップルスクリプトを実行する。
- (void)openURL:(NSString *)scriptfile {
    NSString *path;
    NSURL *url;
    NSAppleScript *script;
    NSDictionary *errorInfo = nil;
    
    path = [[[NSBundle mainBundle] resourcePath] stringByAppendingPathComponent:scriptfile];
    url = [NSURL fileURLWithPath:path];
    script = [[NSAppleScript alloc] initWithContentsOfURL:url error:&errorInfo];
    [script executeAndReturnError:&errorInfo];
    [script release];
}

// アップルスクリプトの戻り値を返す
- (NSString *)getInfo:(NSString *)scriptfile {
    NSString *path;
    NSURL *url;
    NSAppleScript *script;
    NSDictionary *errorInfo = nil;
	NSAppleEventDescriptor *aed;
	
    path = [[[NSBundle mainBundle] resourcePath] stringByAppendingPathComponent:scriptfile];
    url = [NSURL fileURLWithPath:path];
    script = [[NSAppleScript alloc] initWithContentsOfURL:url error:&errorInfo];

    aed = [script executeAndReturnError:&errorInfo];
	[script release];

	return [aed stringValue];
}

// GamePadのボタンが押された時に呼ばれる処理
- (void)pushGamePad:(unsigned long)flags {
	
	// Aボタン
	if (flags & gButtonAMask) {
		if (_pad.a == 1) { // 押された時の処理
			[self openURL:@"play.applescript"];
//			[self openURL:@"playpause.applescript"];
			[_a highlight:YES];
#ifdef DEBUG_GAMEPAD
			NSLog(@"Push A");
#endif
		} else { // ボタンが離れた時の処理
			[_a highlight:NO];
#ifdef DEBUG_GAMEPAD
			NSLog(@"Separate A");
#endif
		}
	}
	// Bボタン
	if (flags & gButtonBMask) {
		if (_pad.b == 1) {
			[_b highlight:YES];
			[self openURL:@"stop.applescript"];
#ifdef DEBUG_GAMEPAD
			NSLog(@"Push B");
#endif
		}else {
			[_b highlight:NO];
		}
	}
	// Cボタン
	if (flags & gButtonCMask) {
		if (_pad.c == 1) {
			[_c highlight:YES];
			[self openURL:@"playpause.applescript"];
//			[self openURL:@"play.applescript"];
#ifdef DEBUG_GAMEPAD
			NSLog(@"Push C");
#endif
		}else {
			[_c highlight:NO];
		}
	}
	// Xボタン
	if (flags & gButtonXMask) {
		if (_pad.x == 1) {
			[_x highlight:YES];
			[self openURL:@"back_track.applescript"];
#ifdef DEBUG_GAMEPAD
			NSLog(@"Push X");
#endif
		}else {
			[_x highlight:NO];
		}
	}
	// Yボタン
	if (flags & gButtonYMask) {
		if (_pad.y == 1) {
			[_y highlight:YES];
			[self openURL:@"minus_volume.applescript"];
#ifdef DEBUG_GAMEPAD
			NSLog(@"Push Y");
#endif
		}else {
			[_y highlight:NO];
		}
	}
	// Zボタン
	if (flags & gButtonZMask) {
		if (_pad.z == 1) {
			[_z highlight:YES];
			[self openURL:@"plus_volume.applescript"];
#ifdef DEBUG_GAMEPAD
			NSLog(@"Push Z");
#endif
		}else {
			[_z highlight:NO];
		}
	}
	// Lボタン
	if (flags & gButtonLMask) {
		if (_pad.l == 1) {
			[_l highlight:YES];
			[self openURL:@"min.applescript"];
#ifdef DEBUG_GAMEPAD
			NSLog(@"Push L");
#endif
		}else {
			[_l highlight:NO];
		}
	}
	// Rボタン
	if (flags & gButtonRMask) {
		if (_pad.r == 1) {
			[_r highlight:YES];
			[self openURL:@"max.applescript"];
#ifdef DEBUG_GAMEPAD
			NSLog(@"Push R");
#endif
		}else {
			[_r highlight:NO];
		}
	}
	// STARTボタン
	if (flags & gButtonStartMask) {
		if (_pad.start == 1) {
			[_start highlight:YES];
			[self openURL:@"start.applescript"];
#ifdef DEBUG_GAMEPAD
			NSLog(@"Push Start");
#endif
		}else {
			[_start highlight:NO];
		}
	}
	// 十字キー(左右)
	if (flags & gButtonXXMask) {
		if (_pad.xx == 0x00) { // 左に押された時の処理
			[_left highlight:YES];
//			[self openURL:@"previous_track.applescript"];
			[self openURL:@"up_playlist.applescript"];
#ifdef DEBUG_GAMEPAD
			NSLog(@"Push XX L");
#endif
		} else if (_pad.xx == 0xff) {
			[_right highlight:YES]; // 右に押された時の処理
//			[self openURL:@"next_track.applescript"];
			[self openURL:@"down_playlist.applescript"];
#ifdef DEBUG_GAMEPAD
			NSLog(@"Push XX R");
#endif
		} else { // 離れた時の処理
			[_left highlight:NO];
			[_right highlight:NO];
		}
	}
	// 十字キー(上下)
	if (flags & gButtonYYMask) {
		if (_pad.yy == 0x00) { // 上に押された時の処理
			[_up highlight:YES];
			[self openURL:@"previous_track.applescript"];
#ifdef DEBUG_GAMEPAD
			NSLog(@"Push YY Up");
#endif
		} else if (_pad.yy == 0xff) { // 下に押された時の処理
			[_down highlight:YES];
			[self openURL:@"next_track.applescript"];
#ifdef DEBUG_GAMEPAD
			NSLog(@"Push XX Down");
#endif
		} else { // 離れた時の処理
			[_up highlight:NO];
			[_down highlight:NO];
		}		
	}

	[self setNameArtist];
}

- (void)dealloc {
	[_observation invalidate];
	HIDReleaseDeviceList();
}

// GamePadのデバイスを返す
- (pRecDevice)getSetCurrentDevice {
	pRecDevice pHIDDevice;
    pRecDevice pCurrentHIDDevice = NULL;

	pHIDDevice = HIDGetFirstDevice();

	while (pHIDDevice != NULL) {
//		NSLog(@"VendorID %lx", pHIDDevice->vendorID);

		if ((pHIDDevice->vendorID == 0x04B4) && (pHIDDevice->productID == 0x010A)) {
//			NSLog(@"found");
			pCurrentHIDDevice = pHIDDevice;
			break;
		}
		pHIDDevice = HIDGetNextDevice(pHIDDevice);
	}

	return pCurrentHIDDevice;
}

// ウインドウ内のボタンを押した時の処理
- (IBAction)pushButton:(id)sender {
	int number;
	number = [sender tag];

	switch (number) {
		case 0: // A
			[self openURL:@"play.applescript"];
//			[self openURL:@"playpause.applescript"];
		break;
		case 1: // B
			[self openURL:@"stop.applescript"];
		break;
		case 2: // C
			[self openURL:@"playpause.applescript"];
//			[self openURL:@"play.applescript"];
		break;
		case 3: // X
			[self openURL:@"back_track.applescript"];
		break;
		case 4: // Y
			[self openURL:@"minus_volume.applescript"];
		break;
		case 5: // Z
			[self openURL:@"plus_volume.applescript"];
		break;
		case 6: // L
			[self openURL:@"min.applescript"];
		break;
		case 7: // R
			[self openURL:@"max.applescript"];
		break;
		case 8: // START
			[self openURL:@"start.applescript"];
		break;
		case 9: // Left
//			[self openURL:@"previous_track.applescript"];
			[self openURL:@"up_playlist.applescript"];
		break;
		case 10: // Right
//			[self openURL:@"next_track.applescript"];
			[self openURL:@"down_playlist.applescript"];
		break;
		case 11: // Down
			[self openURL:@"next_track.applescript"];
		break;
		case 12: // Up
			[self openURL:@"previous_track.applescript"];	
		break;
	}
	[self setNameArtist];
}

// テキストフィールドに情報を設定する
- (void)setNameArtist {
	NSString *name;
	NSString *artist;

	name = [self getInfo:@"getInfoName.applescript"];
	artist = [self getInfo:@"getInfoArtist.applescript"];
	if (name != nil)
		[_title_name setStringValue:name];
	if (name != nil)
		[_title_artist setStringValue:artist];
}

@end
